<template>
  <!-- 随访调查 -->
  <div class="screeningSearch">
    <div class="top">
      <form-components
        :forms="formList"
        :formEdit="formEdit"
        @handleSearch="onSearch"
      ></form-components>
    </div>
    <div class="bot">
      <el-table-self
        ref="table"
        :table-data="tableData"
        :columns="columns"
        :header-class="'newHeader'"
        :list-loading="listLoading"
        :current-page="pageIndex"
        :total-count="total"
        :page-sizes="pageSizes"
        :page-size="pageSize"
        @pageSizeChange="handleSizeChange"
        @currentPageChange="handleCurrentChange"
      />
    </div>
  </div>
</template>
<script>
import FormComponents from "@/components/FormComponents"
import paginationMixin from "@/components/TabComponents/mixin"
import searchMixin from "../searchMixin"
import { getCurrentFormByType } from "@/api/coop-group.js"
import { getFollowSurvey } from "@/api/followup"
import { mapGetters } from "vuex"
export default {
  components: {
    FormComponents,
  },
  mixins: [paginationMixin, searchMixin],
  data() {
    return {
      formId: "", //随访表单类型
      listLoading: false,
      keyword: "",
      modifiedFlag: false,
      columns: [
        {
          label: "医联体",
          minWidth: 120,
          value: "unionName",
          formatter: (row) => {
            return row.unionName ? row.unionName : "--"
          },
        },
        {
          label: "姓名",
          minWidth: 120,
          formatter: (row) => {
            return row.name ? row.name : "--"
          },
          value: "name",
        },
        {
          label: "性别",
          minWidth: 80,
          value: "sex",
          formatter: (row) => {
            return this.$handle.formatDicList(
              this.dictMap["d-sex"],
              row.sex + ""
            )
          },
        },
        {
          label: "身份证",
          minWidth: 120,
          value: "idCard",
          formatter: (row) => {
            return row.idCard ? row.idCard : "--"
          },
        },
        {
          label: "年龄",
          minWidth: 120,
          value: "age",
          formatter: (row) => {
            return row.age ? row.age : "--"
          },
        },
        {
          label: "筛查时间",
          minWidth: 180,
          value: "screeningTime",
          formatter: (row) => {
            return row.screeningTime ? row.screeningTime : "--"
          },
        },
        {
          label: "风险评估结果",
          minWidth: 120,
          value: "riskRank",
          formatter: (row) => {
            let riskRank = {
              low: "低危",
              medium: "中危",
              high: "高危",
            }
            return row.riskRank ? riskRank[row.riskRank] : "--"
          },
        },
        {
          label: "上次随访时间",
          value: "followTime",
          minWidth: 120,
          formatter: (row) => {
            return row.followTime ? row.followTime : "--"
          },
        },
        {
          label: "随访进度",
          value: "followBatch",
          minWidth: 120,
          formatter: (row) => {
            return this.$handle.formatDicList(
              this.dictMap["follow_type"],
              String(row.followBatch)
            )
          },
        },
        {
          label: "计划随访时间",
          value: "nextFollowTime",
          // formatter: (row) => {
          //   return this.$handle.formatDicList(
          //     this.dictMap["next_follow_time"],
          //     String(row.nextFollowTime)
          //   )
          // },
          minWidth: 120,
        },
        {
          label: "操作",
          width: 220,
          fixed: "right",
          operType: "button",
          operations: [
            {
              func: this.rowOpration,
              formatter(row) {
                return {
                  label: " 录入",
                  type: "text",
                }
              },
            },
          ],
        },
      ],
      tableData: [],
      formList: [
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "select",
          label: "计划随访时间",
          prop: "nextFollowTime",
          trans: "next_follow_time",
          placeholder: "请选择计划随访时间",
          rules: [],
          opts: [{ label: "123", value: "1" }],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "input",
          label: "姓名",
          prop: "name",
          placeholder: "请输入姓名",
          rules: [],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "input",
          label: "身份证",
          prop: "idCard",
          placeholder: "请输入身份证",
          rules: [],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "input",
          label: "医联体",
          prop: "unionName",
          placeholder: "请输入医联体",
          rules: [],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "select",
          label: "随访进度",
          prop: "followBatch",
          trans: "follow_type",
          placeholder: "请选择随访进度",
          rules: [],
          opts: [
            { label: "筛查", value: "0" },
            { label: "随访", value: "1" },
          ],
        },
        {
          xs: 1,
          sm: 2,
          md: 2,
          lg: 2,
          xl: 2,
          type: "btn",
          list: [
            {
              btnType: "button",
              type: "",
              style: {
                width: "80px",
                height: "32px",
                borderRadius: "4px",
                fontSize: "14px",
                marginLeft: "40px",
              },
              btnText: "查询",
              func: this.onSearch,
            },
            // {
            //   btnType: "tobeModified",
            //   tobeModified: 20,
            // },
          ],
        },
      ],
      formEdit: {},
    }
  },
  computed: {
    ...mapGetters({
      // selectedIndex: "table/selectedIndex",
      refreshFlag: "table/refreshFlag",
    }),
  },
  watch: {},
  created() {
    this.initSearchForm()
  },
  mounted() {
    this.handleSearch() //调试注释
  },
  methods: {
    changeModified() {
      this.modifiedFlag = !this.modifiedFlag
    },
    changePage(v) {
      this.page[v.type] = v.value
      console.log(this.page)
      this.$refs.customTable.loading = false
    },
    onSearch(form) {
      sessionStorage.setItem("followResearch-form", JSON.stringify(form))
      this.formEdit = form
      this.pageIndex = 1
      this.handleSearch()
    },
    rowOpration(data, i) {
      console.log("跳转", data, i)
      sessionStorage.setItem("formEdit", JSON.stringify(data))
      this.$router.push({
        path: `/followupentry`,
        query: {
          patientId: data.patientId,
          getData: 0,
          formType: "2",
          model: "add",
        },
      })
    },
    async handleSearch() {
      this.listLoading = true
      let params = {
        pageSize: this.pageSize,
        pageNum: this.pageIndex,
      }
      params.patientFrom = this.selectedIndex
      if (this.formEdit) {
        params = Object.assign(this.formEdit, params)
      }
      let res = await getFollowSurvey(params)
      if (res.code == 1) {
        //分页内容
        const d = res.data
        this.total = d.total
        this.tableData = d["records"]
      }
      this.listLoading = false
    },
    //查询表单枚举值字典
    initSearchForm() {
      this.formList.forEach((item, index) => {
        if (item.trans) {
          if (!item["opts"]) {
            item["opts"] = []
          } else {
            item["opts"] = this.dictMap[item.trans]
          }
        }
      })
      this.$forceUpdate()
    },
    // async initDict(type,index){
    //   let params={
    //     type:type
    //   }
    //   const res = await getDictDetail(params)
    //   let item = this.formList.find(_ => _.trans == type)
    //   res.data.forEach((itemD,inx) => {
    //     // if(!this.columns[index]['transList']){
    //     //    this.columns[index]['transList']={}
    //     // }
    //     // else{
    //     //   this.columns[index]['transList'][itemD.code]=itemD.name
    //     // }
    //     if(item){
    //       if(!item['opts']){
    //        item['opts']=[]
    //     }
    //     else {
    //         item['opts']=res.data.map((_) => {
    //           return {
    //             label: _.name,
    //             value: _.code,
    //           }
    //         })
    //       }
    //     }
    //   })
    // },
    //获取随访表单类型
    getCurrentFormByType(type) {
      getCurrentFormByType({
        type,
        groupId: this.$store.state.user.group.groupId || "",
      }).then((res) => {
        if (res.code === 1) {
          this.formId = res.data[0].id
          this.handleSearch()
        }
      })
    },
  },
}
</script>
<style lang="scss" scoped>
.screeningSearch {
  .top {
    width: 100%;
    // height: 72px;
    padding: 0 116px 0 44px;
    display: flex;
    justify-content: space-between;
    align-items: center;
  }
  .bot {
    padding: 0 24px;
  }
}
</style>
